<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcMover Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcMover Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcMover" --><!-- doxytag: inherits="iBase" -->
<p>This is a mover property class.  
 <a href="structiPcMover.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="mover_8h_source.html">propclass/mover.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcMover:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcMover.png" usemap="#iPcMover_map" alt=""/>
  <map id="iPcMover_map" name="iPcMover_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,67,24"/>
</map>
 </div></div>

<p><a href="structiPcMover-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#a5f58ad51460557295127d5db9de38a9e">GetPosition</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the end position that we want to move to.  <a href="#a5f58ad51460557295127d5db9de38a9e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#aeb829d9c04839839b88e112aa5fd40e5">GetSector</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the end sector that we want to move to.  <a href="#aeb829d9c04839839b88e112aa5fd40e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#ae60ce1280532879b36967e9a0ad6d1be">GetSqRadius</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the current squared radius.  <a href="#ae60ce1280532879b36967e9a0ad6d1be"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#a7e24d6084153388422e7f0e5d012d323">GetUp</a> () const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#aef9fd44048ab80df57beef6b84b759ca">Interrupt</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interrupt a movement.  <a href="#aef9fd44048ab80df57beef6b84b759ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#a3f2b4075828ad7b5efbc7fa19e1240c5">IsMoving</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if currently moving.  <a href="#a3f2b4075828ad7b5efbc7fa19e1240c5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#aa045fb6ec5c763c5b65fe2bf08304083">IsSmoothMovement</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if the rotations used during the movement will be smooth and false if they will be sudden.  <a href="#aa045fb6ec5c763c5b65fe2bf08304083"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#aceaccd7122828421968b9bf2088c4698">MoveTo</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;position, float sqradius, bool checklos=false)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move to the specified position.  <a href="#aceaccd7122828421968b9bf2088c4698"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#a6ea7bc7c259a103a0ccc507ee5e2a3c0">SetSmoothMovement</a> (bool smooth)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Define if the movement will have sudden of smooth turns.  <a href="#a6ea7bc7c259a103a0ccc507ee5e2a3c0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMover.html#a5a42e040276e64d0f9f624170172659f">Start</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;position, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;up, float sqradius)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Start moving.  <a href="#a5a42e040276e64d0f9f624170172659f"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a mover property class. </p>
<p>It works closely with pclinmove and pcactormove in order to move an object from one position to another while checking collision detection along the way.</p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.move.impossible' (old 'pcmover_impossible'): don't even start the move: impossible. This message will have a 'meshname' parameter containing the name of the mesh that was preventing the move.</li>
<li>'cel.move.arrived' (old 'pcmover_arrived'): arrived at final position.</li>
<li>'cel.move.interrupted' (old 'pcmover_interrupted'): movement has been interrupted.</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.mover.action.' if you want to access this action through a message):</p>
<ul>
<li>MoveTo: parameters 'sectorname' (string), 'position' (vector3), ,'sqradius' (float) and optional 'checklos' (bool, default false).</li>
<li>Start: parameters 'sectorname' (string), 'position' (vector3), 'up' (vector3), and 'sqradius' (float). This action is deprecated, you should use MoveTo instead.</li>
<li>Interrupt: interrupt the current movement.</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>position (vector3, read only): current end position.</li>
<li>sqradius (float, read/write): current squared radius.</li>
<li>moving (bool, read only): returns true if currently moving. </li>
</ul>

<p>Definition at line <a class="el" href="mover_8h_source.html#l00054">54</a> of file <a class="el" href="mover_8h_source.html">mover.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a5f58ad51460557295127d5db9de38a9e"></a><!-- doxytag: member="iPcMover::GetPosition" ref="a5f58ad51460557295127d5db9de38a9e" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcMover.html#a5f58ad51460557295127d5db9de38a9e">iPcMover::GetPosition</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the end position that we want to move to. </p>

</div>
</div>
<a class="anchor" id="aeb829d9c04839839b88e112aa5fd40e5"></a><!-- doxytag: member="iPcMover::GetSector" ref="aeb829d9c04839839b88e112aa5fd40e5" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="el" href="structiPcMover.html#aeb829d9c04839839b88e112aa5fd40e5">iPcMover::GetSector</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the end sector that we want to move to. </p>

</div>
</div>
<a class="anchor" id="ae60ce1280532879b36967e9a0ad6d1be"></a><!-- doxytag: member="iPcMover::GetSqRadius" ref="ae60ce1280532879b36967e9a0ad6d1be" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcMover.html#ae60ce1280532879b36967e9a0ad6d1be">iPcMover::GetSqRadius</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the current squared radius. </p>

</div>
</div>
<a class="anchor" id="a7e24d6084153388422e7f0e5d012d323"></a><!-- doxytag: member="iPcMover::GetUp" ref="a7e24d6084153388422e7f0e5d012d323" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcMover.html#a7e24d6084153388422e7f0e5d012d323">iPcMover::GetUp</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000003">Deprecated:</a></b></dt><dd>Handling of up vector by pcmover is deprecated.</dd></dl>

</div>
</div>
<a class="anchor" id="aef9fd44048ab80df57beef6b84b759ca"></a><!-- doxytag: member="iPcMover::Interrupt" ref="aef9fd44048ab80df57beef6b84b759ca" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMover.html#aef9fd44048ab80df57beef6b84b759ca">iPcMover::Interrupt</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Interrupt a movement. </p>
<p>The behaviour will get a 'pcmover_interrupted' message if the mover was really moving. Otherwise nothing happens. </p>

</div>
</div>
<a class="anchor" id="a3f2b4075828ad7b5efbc7fa19e1240c5"></a><!-- doxytag: member="iPcMover::IsMoving" ref="a3f2b4075828ad7b5efbc7fa19e1240c5" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMover.html#a3f2b4075828ad7b5efbc7fa19e1240c5">iPcMover::IsMoving</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if currently moving. </p>

</div>
</div>
<a class="anchor" id="aa045fb6ec5c763c5b65fe2bf08304083"></a><!-- doxytag: member="iPcMover::IsSmoothMovement" ref="aa045fb6ec5c763c5b65fe2bf08304083" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMover.html#aa045fb6ec5c763c5b65fe2bf08304083">iPcMover::IsSmoothMovement</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if the rotations used during the movement will be smooth and false if they will be sudden. </p>

</div>
</div>
<a class="anchor" id="aceaccd7122828421968b9bf2088c4698"></a><!-- doxytag: member="iPcMover::MoveTo" ref="aceaccd7122828421968b9bf2088c4698" args="(iSector *sector, const csVector3 &amp;position, float sqradius, bool checklos=false)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMover.html#aceaccd7122828421968b9bf2088c4698">iPcMover::MoveTo</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sqradius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>checklos</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move to the specified position. </p>
<p>When you call this function this property class will attempt to move the linmove to the correct position. If it fails the behaviour will get a 'pcmover_stuck' message. Otherwise it will get a 'pcmover_arrived' message. If checklos parameter is true a line of sight test will be made in advance, and if this function detects that line of sight is blocked then the behaviour will get a 'pcmover_impossible' message and this function will return false then. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcmover_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sector</td><td>is the desired sector to move to. </td></tr>
    <tr><td class="paramname">position</td><td>is the desired position to move to. </td></tr>
    <tr><td class="paramname">sqradius</td><td>if the linmove ends up within the given squared radius of the desired position the movement will stop and be considered sucessful. </td></tr>
    <tr><td class="paramname">checklos</td><td>whether to check line of sight to destination on movement start. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6ea7bc7c259a103a0ccc507ee5e2a3c0"></a><!-- doxytag: member="iPcMover::SetSmoothMovement" ref="a6ea7bc7c259a103a0ccc507ee5e2a3c0" args="(bool smooth)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMover.html#a6ea7bc7c259a103a0ccc507ee5e2a3c0">iPcMover::SetSmoothMovement</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>smooth</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Define if the movement will have sudden of smooth turns. </p>
<p>Having sudden turns will ensure the movement is done in straight lines. </p>

</div>
</div>
<a class="anchor" id="a5a42e040276e64d0f9f624170172659f"></a><!-- doxytag: member="iPcMover::Start" ref="a5a42e040276e64d0f9f624170172659f" args="(iSector *sector, const csVector3 &amp;position, const csVector3 &amp;up, float sqradius)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMover.html#a5a42e040276e64d0f9f624170172659f">iPcMover::Start</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>up</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sqradius</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Start moving. </p>
<p>When you call this function this property class will attempt to move the linmove to the correct position. If it fails the behaviour will get a 'pcmover_stuck' message. Otherwise it will get a 'pcmover_arrived' message. If this function detects that it is completely impossible to move there in advance then the behaviour will get a 'pcmover_impossible' message and this function will return false then. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcmover_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sector</td><td>is the desired sector to move to. </td></tr>
    <tr><td class="paramname">position</td><td>is the desired position to move to. </td></tr>
    <tr><td class="paramname">up</td><td>is the up vector (used for rotation). </td></tr>
    <tr><td class="paramname">sqradius</td><td>if the linmove ends up within the given squared radius of the desired position the movement will stop and be considered sucessful. </td></tr>
  </table>
  </dd>
</dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000002">Deprecated:</a></b></dt><dd>Use MoveTo instead. </dd></dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="mover_8h_source.html">mover.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
